local mod_path = ModPath
local default_localization_file = "english.txt"
Hooks:Add("LocalizationManagerPostInit", "defiance_perkdeck_add_localization", function( localizationmanager )
	if not BeardLib then 
		--load from the loc file and add localized strings if not using beardlib
		--unfortunately, superblt doesn't handle parsing macros well when adding localized strings,
		--so beardlib is preferred, since it can handle adding the localization files without messing up the macros
		
		localizationmanager:load_localization_file( mod_path .. "loc/" .. default_localization_file)
	end

end)
