Hooks:PreHook(NewRaycastWeaponBase,"on_reload","defiance_perkdeck_pre_on_reloaded",function(self)
	managers.player:remove_property("defiance_electrocutioner_reload_speed_bonus")
	
	local pm = managers.player
	local td = tweak_data.upgrades.values.player.defiance
	
	if self:get_ammo_remaining_in_clip() == 0 then 
		
		if pm:has_category_upgrade("player","defiance_on_the_run") then 
		
			if self._can_use_defiance_on_the_run == nil then 
				local name_id = self:get_name_id()
				if td.on_the_run.weapons_list[name_id] ~= nil then  
					local can_use = td.on_the_run.weapons_list[name_id]
					self._can_use_defiance_on_the_run = can_use
					if not can_use then 
						return
					end
				elseif self:is_category(unpack(td.on_the_run.blacklisted_categories)) then 
					self._can_use_defiance_on_the_run = false
					return
				else
					self._can_use_defiance_on_the_run = true
				end
			end
			if self._can_use_defiance_on_the_run then 
				if not pm:has_active_temporary_property("defiance_move_speed_cooldown") then
					pm:activate_temporary_property("defiance_move_speed_cooldown",td.on_the_run.cooldown,true)
					pm:activate_temporary_property("defiance_move_speed_bonus",td.on_the_run.duration,td.on_the_run.movement_speed_bonus)
				end
			end
		end
	end
end)

local defianceperkdeck_orig_reload_speed_multiplier = NewRaycastWeaponBase.reload_speed_multiplier
function NewRaycastWeaponBase:reload_speed_multiplier(...)
	local multiplier = defianceperkdeck_orig_reload_speed_multiplier(self,...)
	return multiplier + managers.player:get_property("defiance_electrocutioner_reload_speed_bonus",0)
end
